//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkMeshManager_tool.h"
#include "bbcreaVtkPackage.h"
namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,MeshManager_tool)
BBTK_BLACK_BOX_IMPLEMENTATION(MeshManager_tool,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void MeshManager_tool::Process()
{
// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')
//    bbSetOutputOut( bbGetInputIn() );
//    std::cout << "Output value = " <<bbGetOutputOut() << std::endl;
    
    if (bbGetInputMeshManagerModel()!=NULL)
    {
        if (bbGetInputTool()==10) // Undo
        {
            printf("EED Warning!   MeshManager_tool Undo   Not implemented.\n");
        } // if Tool 10 Undo
        
        if (bbGetInputTool()==20) // Redo
        {
            printf("EED Warning!   MeshManager_tool Redo   Not implemented.\n");
        } // if Tool 20 Redo

        if (bbGetInputTool()==30)  // Set
        {
            if (bbGetInputMesh()!=NULL){
                vtkPoints   *points = bbGetInputMesh()->GetPoints();
                if (points!=NULL)
                {
                    bbGetInputMeshManagerModel()->SetMeshBase( bbGetInputMesh() );
                } // if points!=NULL
            } // Mesh!=NULL
        } // if Tool 30 Set

        if (bbGetInputTool()==35)  // Set memory mode
        {
                bbGetInputMeshManagerModel()->SetMeshMemoryMode( bbGetInputMesh() );
        } // if Tool 35 Set memory mode

        if (bbGetInputTool()==32)  // Copy and Set
        {
                bbGetInputMeshManagerModel()->CopySetMeshBase( bbGetInputMesh() );
        } // if Tool 35 Set memory mode

        
        if (bbGetInputTool()==40) // ResetMeshTemp
        {
            printf("EED MeshManager_tool::Process ResetMeshTemp 1\n");
            bbGetInputMeshManagerModel()->ResetMeshTemp();
            printf("EED MeshManager_tool::Process ResetMeshTemp 2\n");
        } // if Tool 40 Reset
        
    } else {
        printf("EED Warning! MeshManager_tool : MeshManagerModel not defined. \n");
    }// if MeshManagerModel != NULL
}

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void MeshManager_tool::bbUserSetDefaultValues()
{
//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
   bbSetInputTool(0);
   bbSetInputMesh(NULL);
   bbSetInputMeshManagerModel(NULL);
}

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void MeshManager_tool::bbUserInitializeProcessing()
{
//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void MeshManager_tool::bbUserFinalizeProcessing()
{
//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
}

} // EO namespace bbcreaVtk


