//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkPlaneSource.h"
#include "bbcreaVtkPackage.h"
#include "vtkPlaneSource.h"
#include "vtkDataSet.h"
#include "iostream" 
namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,PlaneSource)
BBTK_BLACK_BOX_IMPLEMENTATION(PlaneSource,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void PlaneSource::Process()
{
	double c[3];
 	double p0[3];
    double p1[3];
	double p2[3];
	vtkPlaneSource *plane;
	plane 	= 	vtkPlaneSource::New();
	c[0]	=	bbGetInputCenter()[0];
	c[1]	=	bbGetInputCenter()[1];
	c[2]	=	bbGetInputCenter()[2];
	p0[0] 	=	0;	
	p0[1] 	=	0;
	p0[2] 	=	0;


	bool byNormal=true; 	
	double size=350;

	// xy
	if ((bbGetInputNormal()[0]==0) && (bbGetInputNormal()[1]==0) && (bbGetInputNormal()[2]==1)  ) 
	{
		byNormal=	false;
		p1[0] 	=	size;	
		p1[1] 	=	0;
		p1[2] 	=	0;    
		p2[0]	=	0;
		p2[1] 	=	size;
		p2[2] 	=	0;
	}
	
	// xz
	if ((bbGetInputNormal()[0]==0) && (bbGetInputNormal()[1]==1) && (bbGetInputNormal()[2]==0)  ) 
	{
		byNormal=	false;
		p1[0] 	=	size;	
		p1[1] 	=	0;
		p1[2] 	=	0;    
		p2[0]	=	0;
		p2[1] 	=	0;
		p2[2] 	=	size;
	}

	// yz
	if ((bbGetInputNormal()[0]==1) && (bbGetInputNormal()[1]==0) && (bbGetInputNormal()[2]==0)  ) 
	{
		byNormal=	false;
		p1[0] 	=	0;	
		p1[1] 	=	size;
		p1[2] 	=	0;    
		p2[0]	=	0;
		p2[1] 	=	0;
		p2[2] 	=	size;
	}

		plane->SetResolution( bbGetInputXResolution(), bbGetInputYResolution() );
		if (byNormal==false)
		{
			plane->SetOrigin( p0 );		
			plane->SetPoint1( p1 );
			plane->SetPoint2( p2 );
		} else {
			plane->SetNormal( bbGetInputNormal()[0], bbGetInputNormal()[1], bbGetInputNormal()[2] );
			printf("EED PlaneSource. Missing mechanism to define the size of the plane\n");
		}
			plane->SetCenter( c );

		plane->Update( );
    bbSetOutputPlane( (vtkDataSet*)plane );
    bbSetOutputPolyData( plane->GetOutput() );

}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void PlaneSource::bbUserSetDefaultValues()
{
   std::vector<double> c;
   std::vector<double> n;
	c.push_back(0);
	c.push_back(0);
	c.push_back(0);
	n.push_back(1);
	n.push_back(0);
	n.push_back(0);
   bbSetInputCenter(c);
   bbSetInputNormal(n);
   bbSetInputXResolution(100);
   bbSetInputYResolution(100);
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void PlaneSource::bbUserInitializeProcessing()
{

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void PlaneSource::bbUserFinalizeProcessing()
{

  
}
}
// EO namespace bbcreaVtk


