//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#ifndef __bbcreaVtkCreateMeshFromPoints_h_INCLUDED__
#define __bbcreaVtkCreateMeshFromPoints_h_INCLUDED__

#include "bbcreaVtk_EXPORT.h"
#include "bbtkAtomicBlackBox.h"
#include "iostream"

#include "vtkPoints.h"
#include "vtkCellArray.h"
#include "vtkPolyData.h"
#include "vtkCleanPolyData.h"
#include "vtkTriangleFilter.h"


namespace bbcreaVtk
{

class bbcreaVtk_EXPORT CreateMeshFromPoints
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(CreateMeshFromPoints,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
  BBTK_DECLARE_INPUT(LstX,std::vector<double>);
  BBTK_DECLARE_INPUT(LstY,std::vector<double>);
  BBTK_DECLARE_INPUT(LstZ,std::vector<double>);
  BBTK_DECLARE_INPUT(LstIndexs,std::vector<int>);
  BBTK_DECLARE_OUTPUT(Out,vtkPolyData*);
  BBTK_PROCESS(Process);
  void Process();

 	vtkPoints 			*points;
	vtkCellArray 		*cells;
	vtkPolyData 		*polydata;
	vtkCleanPolyData 	*clean;
	vtkTriangleFilter 	*triangle;

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(CreateMeshFromPoints,bbtk::AtomicBlackBox);
  BBTK_NAME("CreateMeshFromPoints");
  BBTK_AUTHOR("InfoDev");
  BBTK_DESCRIPTION("No Description.");
  BBTK_CATEGORY("empty");

  BBTK_INPUT(CreateMeshFromPoints,LstX,"List X point",std::vector<double>,"");
  BBTK_INPUT(CreateMeshFromPoints,LstY,"List Y point",std::vector<double>,"");
  BBTK_INPUT(CreateMeshFromPoints,LstZ,"List Z point",std::vector<double>,"");
  BBTK_INPUT(CreateMeshFromPoints,LstIndexs,"Number of points by segment",std::vector<int>,"");

  BBTK_OUTPUT(CreateMeshFromPoints,Out,"vtkPolyData",vtkPolyData*,"");

BBTK_END_DESCRIBE_BLACK_BOX(CreateMeshFromPoints);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
}
// EO namespace bbcreaVtk

#endif // __bbcreaVtkCreateMeshFromPoints_h_INCLUDED__

