//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkLinearExtrusionFilter.h"
#include "bbcreaVtkPackage.h"
#include <vtkReverseSense.h>

namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,LinearExtrusionFilter)
BBTK_BLACK_BOX_IMPLEMENTATION(LinearExtrusionFilter,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void LinearExtrusionFilter::Process()
{
// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')
//    bbSetOutputOut( bbGetInputIn() );
//    std::cout << "Output value = " <<bbGetOutputOut() << std::endl;
    
    if (extrude!=NULL)
    {
        extrude->Delete();
        extrude=NULL;
    }
    if (triangleFilter!=NULL)
    {
        triangleFilter->Delete();
        triangleFilter=NULL;
    }

    if (bbGetInputIn()!=NULL)
    {
        std::vector<double>     dir             = bbGetInputDirection();
                                extrude         = vtkLinearExtrusionFilter::New();
                                triangleFilter  = vtkTriangleFilter::New();
        extrude->SetInputData( bbGetInputIn() );
        extrude->SetExtrusionTypeToNormalExtrusion();
        if (dir.size()==3)
        {
            extrude->SetVector( dir[0],dir[1],dir[2] );
        } else {
            extrude->SetVector(1, 0, 0);
        }
        extrude->SetScaleFactor( bbGetInputScalarFactor() );
        extrude->Update();
        triangleFilter->SetInputData( extrude->GetOutput() );
        triangleFilter->Update( );
        bbSetOutputOut( triangleFilter->GetOutput() );
    } else {
        bbSetOutputOut( NULL );
    }// if bbGetInputIn
}

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void LinearExtrusionFilter::bbUserSetDefaultValues()
{
//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
    extrude         = NULL;
    triangleFilter  = NULL;
    bbSetInputIn(NULL);
    std::vector<double> dir;
    dir.push_back(1);
    dir.push_back(0);
    dir.push_back(0);
    bbSetInputDirection( dir );
    bbSetInputScalarFactor(0);
    bbSetOutputOut( NULL );
}

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void LinearExtrusionFilter::bbUserInitializeProcessing()
{
//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any
}

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void LinearExtrusionFilter::bbUserFinalizeProcessing()
{
//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
}

}  // EO namespace bbcreaVtk


