//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkSetCameraInfo.h"
#include "bbcreaVtkPackage.h"

#include "vtkCamera.h"

namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,SetCameraInfo)
BBTK_BLACK_BOX_IMPLEMENTATION(SetCameraInfo,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void SetCameraInfo::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')
	
	if (bbGetInputvtkRenderer()!=NULL)
	{
	  double px,py,pz;
	  px=bbGetInputPosition()[0];
	  py=bbGetInputPosition()[1];
	  pz=bbGetInputPosition()[2];
	  bbGetInputvtkRenderer()->GetActiveCamera()->SetPosition(px,py,pz);
	  double fx,fy,fz;
	  fx=bbGetInputFocalPoint()[0];
	  fy=bbGetInputFocalPoint()[1];
	  fz=bbGetInputFocalPoint()[2];
	  bbGetInputvtkRenderer()->GetActiveCamera()->SetFocalPoint(fx,fy,fz);
	  double vx,vy,vz;
	  vx=bbGetInputViewUp()[0];
	  vy=bbGetInputViewUp()[1];
	  vz=bbGetInputViewUp()[2];
	  bbGetInputvtkRenderer()->GetActiveCamera()->SetViewUp(vx,vy,vz);
	} // if
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void SetCameraInfo::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
   bbSetInputvtkRenderer( NULL );
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void SetCameraInfo::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void SetCameraInfo::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbcreaVtk


